# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Add . to reltag for namedversion to work
%define reltag .Final

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib
%bcond_without tests

%define namedversion %{version}%{reltag}

%define repodir %{_javadir}/repository.jboss.com/jgroups/%{version}%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

Name:           jgroups
Version:        2.6.20
Release:        1.1%{?dist}
Epoch:          1
Summary:        Toolkit for reliable multicast communication
License:        LGPLv2+
URL:            http://www.jgroups.org/
Group:          Development/LIbraries/Java
# git clone git://github.com/belaban/JGroups.git && mv JGroups JGroups-2.6.20.Final && cd JGroups-2.6.20.Final && git checkout JGroups_2_6_20 && cd ..
# HEAD is now at 70fe052...
# tar cjf JGroups-2.6.20.Final.tar.bz2 JGroups-2.6.20.Final
Source0:        JGroups-%{version}%{reltag}.tar.bz2
Source1:        jgroups-component-info.xml
Source2:	jgroups-upload.sh
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
# To use JGroups one needs:
# commons-logging.jar
Requires:       jakarta-commons-logging
# log4j.jar
Requires:       log4j
# To run JGroups you need to have an XML parser installed on your system.
# If you use JDK 1.4 or higher, you can use the parser that is shipped with it.
Requires:       jaxp_parser_impl
# If you want to use the JGroups JMS protocol ( org.jgroups.protocols.JMS ),
# then you will also need to place jms.jar somewhere in your CLASSPATH. 
Requires:       jms
# Place the JAR files somewhere in your CLASSPATH , and you're ready to start
# using JGroups.
# FIXME Do we need bsh at run-time?
Requires:       bsh
#Optional:      mx4j
BuildRequires:  jpackage-utils
BuildRequires:  java-devel >= 0:1.5
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit
BuildRequires:  ant-trax
BuildRequires:  bsh
BuildRequires:  jakarta-commons-logging
BuildRequires:  jaxp_parser_impl
BuildRequires:  jboss-jms-1.1-api
BuildRequires:  junit
BuildRequires:  log4j
BuildRequires:  maven2-plugin-deploy
BuildRequires:  mx4j
BuildRequires:  xalan-j2
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JGroups is a toolkit for reliable multicast communication. (Note that
this doesn't necessarily mean IP Multicast, JGroups can also use
transports such as TCP). It can be used to create groups of processes
whose members can send messages to each other. The main features include

    * Group creation and deletion. Group members can be spread across
      LANs or WANs
    * Joining and leaving of groups
    * Membership detection and notification about joined/left/crashed members
    * Detection and removal of crashed members
    * Sending and receiving of member-to-group messages (point-to-multipoint)
    * Sending and receiving of member-to-member messages (point-to-point)

To use JGroups one needs:
 commons-logging.jar
 log4j.jar

To run JGroups you need to have an XML parser installed on your system.
If you use JDK 1.4 or higher, you can use the parser that is shipped with it.

If you want to use the JGroups JMS protocol ( org.jgroups.protocols.JMS ),
then you will also need to place jms.jar somewhere in your CLASSPATH. 

Place the JAR files somewhere in your CLASSPATH , and you're ready to start
using JGroups.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n JGroups-%{version}%{reltag}

find . -type f -name .cvsignore | xargs -t rm
find . -type f -name "*.jar" | xargs -t rm

# this test requires bouncycastle
rm tests/junit/org/jgroups/protocols/ENCRYPTAsymmetricTest.java

pushd lib
ln -s $(build-classpath ant) .
ln -s $(build-classpath ant-launcher) .
ln -s $(build-classpath ant/ant-junit) .
#BUILD/JGroups-2.4.1.src/lib/bcprov-jdk14-117.jar.no
ln -s $(build-classpath bsh) .
ln -s $(build-classpath commons-logging) .
ln -s $(build-classpath jms) .
ln -s $(build-classpath junit) .
ln -s $(build-classpath log4j) .
ln -s $(build-classpath mx4j/mx4j-jmx) .
ln -s $(build-classpath xalan-j2) .
ln -s $(build-classpath xalan-j2-serializer) .
popd

sed -i -e 's:<groupId>org.jgroups</groupId>:<groupId>jgroups</groupId>:' pom.xml

%build
export CLASSPATH=
export OPT_JAR_LIST=`cat %{_sysconfdir}/ant.d/{junit,trax}`
%if %without tests
%{ant} jar javadoc gossiprouter-service jgroups-service
%else
%{ant} jar javadoc gossiprouter-service jgroups-service testreport
%endif

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
cp -p dist/jgroups-%{version}%{reltag}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
#The following line was commented out because jgroups-core.jar dosen't get generated in this release 2.6.15.GA - gbarreir
#cp -p dist/jgroups-core.jar %{buildroot}%{_javadir}/%{name}-core-%{version}.jar
cp -p dist/jgroups-sources.jar %{buildroot}%{_javadir}/%{name}-sources-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} ${jar/-%{version}/}; done)

# pom
mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap jgroups jgroups %{namedversion} JPP %{name}
%add_to_maven_depmap org.jgroups jgroups %{namedversion} JPP %{name}

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr dist/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# services
mkdir -p %{buildroot}%{_datadir}/%{name}-%{version}
for sar in $(pwd)/dist/*.sar; do
    bsar=$(basename ${sar})
    mkdir -p %{buildroot}%{_datadir}/%{name}-%{version}/${bsar}
    pushd %{buildroot}%{_datadir}/%{name}-%{version}/${bsar}
    %{jar} xf ${sar}
    for jar in `find -type f -name "*.jar"`; do
        rm ${jar}
        bjar=$(basename ${jar/-%{namedversion}/})
        ln -s %{_javadir}/${bjar} ${bjar}
    done
    popd
done
ln -s %{name}-%{version} %{buildroot}%{_datadir}/%{name}

# docs
mkdir -p %{buildroot}%{_docdir}/%{name}-%{version}
cp -pr doc/* %{buildroot}%{_docdir}/%{name}-%{version}

%if %with repolib
mkdir -p %{buildroot}%{repodir}
mkdir -p %{buildroot}%{repodirlib}
cp -p %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{version}%{reltag}-brew/g" %{buildroot}%{repodir}/component-info.xml
mkdir -p %{buildroot}%{repodirsrc}
cp -p %{SOURCE0} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/jgroups.jar
cp -p %{buildroot}%{_javadir}/%{name}-sources-%{version}.jar %{buildroot}%{repodirlib}/jgroups-sources.jar
cp -p pom.xml %{buildroot}%{repodirlib}/jgroups.pom
%{__install} -p -m 755 %{SOURCE2} %{buildroot}%{repodir}/upload.sh
pushd %{buildroot}%{repodir}
./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
popd
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc CREDITS INSTALL.html LICENSE README
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-sources-%{version}.jar
%{_javadir}/%{name}-sources.jar
%dir %{_datadir}/%{name}-%{version}
%dir %{_datadir}/%{name}
%{_datadir}/%{name}-%{version}/gossiprouter-service.sar/
%dir %{_datadir}/%{name}-%{version}/jgroups-service.sar
%dir %{_datadir}/%{name}-%{version}/jgroups-service.sar/META-INF
%{_datadir}/%{name}-%{version}/jgroups-service.sar/META-INF/MANIFEST.MF
%{_datadir}/%{name}-%{version}/jgroups-service.sar/META-INF/jboss-service.xml
%{_datadir}/%{name}-%{version}/jgroups-service.sar/commons-logging.jar
%{_datadir}/%{name}-%{version}/jgroups-service.sar/jg-magic-map.xml
%{_datadir}/%{name}-%{version}/jgroups-service.sar/jgroups.jar
%{_datadir}/%{name}-%{version}/jgroups-service.sar/log4j.jar
%{_datadir}/%{name}-%{version}/jgroups-service.sar/stacks.xml
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Wed Aug 17 2011 Danesh Mondegarian <dmondega@redhat.com> - 1:2.6.20-1.1
- Updated to 2.6.20

* Wed Apr 06 2011 martha Benitez <mbenitez@redhat.com> - 1:2.6.19-2.1
- Remove version from jgroups.jar inside sar

* Tue Feb 15 2011 Martha Benitez <mbenitez@redhat.com> - 1:2.6.19.2
- Upgrade sources to fix Version.java
- Remove EULA

* Fri Feb 11 2011 Martha Benitez <mbenitez@redhat.com> - 1:2.6.19-1
- Upgrade to 2.6.19.Final

* Mon Jan 24 2011 Permaine Cheung <pcheung@redhat.com> - 1:2.6.16-5
- Update groupId to jgroups in pom to match with AS c-m/pom.xml
- Add depmap for groupId org.jgroups

* Mon Jan 24 2011 Permaine Cheung <pcheung@redhat.com> - 1:2.6.16-4
- Rebuild

* Wed Nov 24 2010 Yiqiao Wang <yiwang@redhat.com> - 1:2.6.16-3
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew

* Wed Jul 28 2010 Martha Benitez <mbenitez@redhat.com> - 1:2.6.16-2
- Add jgroups-service.sar/jgroups-2.6.16.GA.jar to main package

* Tue Jul 13 2010 Martha Benitez <mbenitez@redhat.com> - 1:2.6.16-1
- Upgrade to 2.6.16

* Thu Jun 03 2010 Martha Benitez <mbenitez@redhat.com> - 1:2.6.15-1.1
- Upgrade to 2.6.15
- Add jgroups-service.sar/jgroups-%{namedversion}.jar to main package

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 1:2.6.13-1.3.1
- rebuilt

* Tue Apr 20 2010 Weinan Li <weli@redhat.com> 1:2.6.13-1.3
- Rebuild

* Mon Oct 05 2009 David Walluck <dwalluck@redhat.com> 1:2.6.13-1.2
- unpack and install gossiprouter-service.sar
- BuildRequires: jboss-jms-1.1-api for jms

* Fri Oct 02 2009 David Walluck <dwalluck@redhat.com> 1:2.6.13-1.1
- add Requires on jpackage-utils for maven depmap
- don't create unowned/orphaned files in %%post
- java.util.concurrent is used, not concurrent
- move jar symlinks to %%prep

* Fri Oct 02 2009 Martha Benitez <mbenitez@redhat.com> 1:2.6.13-1
- Upgrade to 2.6.13

* Tue Aug 18 2009 Fernando Nasser <fnasser@redhat.com> 1:2.6.12-1
- Upgrade to 2.6.12
- Add pom to buildmagic lib directory
- Add new build targets as suggested by Bela Ban

* Thu Aug 06 2009 Permaine Cheung <pcheung@redhat.com> 1:2.6.11-0.5
- Fix version in maven fragment

* Fri Jul 17 2009 Permaine Cheung <pcheung@redhat.com> 1:2.6.11-0.4
- Fix pom name

* Fri Jul 17 2009 Permaine Cheung <pcheung@redhat.com> 1:2.6.11-0.3
- Add sources.jar

* Fri Jul 17 2009 Permaine Cheung <pcheung@redhat.com> 1:2.6.11-0.2
- Explode jgroups-service.sar
- Add pom

* Fri Jul 17 2009 Permaine Cheung <pcheung@redhat.com> 1:2.6.11-0.1
- Upgrade to 2.6.11

* Thu May 21 2009 Martha Benitez <mbenitez@redhat.com> 1:2.6.10-1.1
- Change jpackage-utils >= 0:1.6 to jpackage-utils >= 0:1.3

* Thu May 21 2009 David Walluck <dwalluck@redhat.com> 1:2.6.10-1
- 2.6.10.GA

* Wed May 20 2009 David Walluck <dwalluck@redhat.com> 1:2.6.9-1
- 2.6.9.GA

* Mon Apr 13 2009 David Walluck <dwalluck@redhat.com> 1:2.6.8-1
- 2.6.8.GA

* Mon Jan 12 2009 David Walluck <dwalluck@redhat.com> 1:2.6.7-1
- 2.6.7.GA
- fix repolib

* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 2.4.1-1.SP4.2
- Auto rebuild for JPackage 5 in mock

* Thu May 29 2008 David Walluck <dwalluck@redhat.com> 1:2.4.1-1.SP4.1.jpp5
- fix License
- remove javadoc scriptlets
- BuildRequires: ant-trax
- fix summary-ended-with-dot
- remove .cvsignore

* Fri Oct 26 2007 Fernando Nasser <fnasser@redhat.com> 1:2.4.1-1.SP4.0jpp.ep1.2
- Use sources from CVS

* Wed Oct 24 2007 Fernando Nasser <fnasser@redhat.com> 1:2.4.1-1.SP4.0jpp.ep1.1
- Upgrade to 2.4.1.SP4

* Tue May 01 2007 Fernando Nasser <fnasser@redhat.com> 0:2.4.1.3-1jpp.ep1.1
- Upgrade to 2.4.1.SP3

* Fri Apr 20 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:2.4.1.2-1jpp.ep1.2
- Fix repodir macro 

* Fri Apr 20 2007 Fernando Nasser <fnasser@redhat.com> 0:2.4.1.2-1jpp.ep1.1
- Upgrade to 2.4.1.SP2

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:2.4.1-1jpp.ep1.3
- Fix typo in repodir (again)

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:2.4.1-1jpp.ep1.2
- Add _javadir to repodir

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> 0:2.4.1.1-1jpp.ep1.1
- Upgrade to 2.4.1.SP1

* Wed Mar 07 2007 Fernando Nasser <fnasser@redhat.com> 0:2.4.1-1jpp.el4ep1.5
- Make mx4j optional

* Tue Feb 20 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:2.4.1-1jpp.el4ep1.4
- Add -brew suffix

* Mon Feb 19 2007 Fernando Nasser <fnasser@redhat.com> 0:2.4.1-1jpp.el4ep1.3
- Build with Java 5, which is now required by the developers
  (will still run with Java 1.4.2)

* Sun Feb 18 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:2.4.1-1jpp.el4ep1.2
- Add repolib support

* Sun Feb 18 2007 Fernando Nasser <fnasser@redhat.com> 0:2.4.1-1jpp.el4ep1.1
- Merge for upgrade

* Sat Feb 17 2007 Fernando Nasser <fnasser@redhat.com> 0:2.4.1-1jpp
- Upgrade to 2.4.1
- Add missing BR for ant-junit
- Add missing BR for xalan-j2
- Disable tests that refer to Java 5 classes
- Remove version and distribution tags

* Tue Aug 01 2006 Fernando Nasser <fnasser@redhat.com> 0:2.3-0.cr1.1jpp_1rh
- Merge for upgrade

* Mon Jun 12 2006 Ralph Apel <r.apel@r-apel.de> 0:2.3-0.cr1.1jpp
- upgrade to 2.3.CR1

* Wed Jun 07 2006 Fernando Nasser <fnasser@redhat.com> 0:2.2.9.2-1jpp_1rh
- Merge for upgrade

* Wed May 31 2006 Ralph Apel <r.apel@r-apel.de> 0:2.2.9.2-1jpp
- upgrade to 2.2.9.2

* Tue May 02 2006 Ralph Apel <r.apel@r-apel.de> 0:2.2.9.1-1jpp
- upgrade to 2.2.9.1

* Sat Jun 04 2005 Fernando Nasser <fnasser@redhat.com> 0:2.2.7-1jpp_1rh
- Merge for upgrade

* Sat Jun 04 2005 Fernando Nasser <fnasser@redhat.com> 0:2.2.7-1jpp
- upgrade to 2.2.7

* Thu Dec 02 2004 Fernando Nasser <fnasser@redhat.com> 0:2.2.6-1jpp_1rh
- First Red Hat release

* Thu Sep 16 2004 Ralph Apel <r.apel at r-apel.de> 0:2.2.6-1jpp
- upgrade to 2.2.6

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:2.2-3jpp
- Rebuild with ant-1.6.2

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:2.2-2jpp
- Upgrade to Ant 1.6.X

* Sun Jan 25 2004 David Walluck <david@anti-microsoft.org> 0:2.2-1jpp
- update source
